%define alpha         017
%define upstreamversion 1.1.1

Summary: A Japanese character set conversion system.
Name: FreeWnn
Version: 1.11
Release: 36.3
Group: Applications/System
License: Distributable
URL: http://www.freewnn.org/
# Original Source is gziped.
Source0: ftp://ftp.freewnn.org/pub/FreeWnn/alpha/%{name}-%{upstreamversion}-a%{alpha}.tar.bz2
Source1: FreeWnn.init
Patch0:	FreeWnn-fsstnd.patch
Patch1:	FreeWnn-ja-a017.patch
Patch2:	FreeWnn-noroot.patch
Patch3:	FreeWnn-noroot2.patch
Patch4:	jserverrc-g-jinmei.patch
# patch for ia64
Patch5: FreeWnn-ia64.patch
Patch6: FreeWnn-shared.patch
Patch7: FreeWnn-reuid.patch
Patch8: FreeWnn-fPIC.patch
Patch9: FreeWnn-nosbit.patch
Patch10: FreeWnn-dirlimit.patch
Patch11: FreeWnn-nonstrip.patch
Patch12: FreeWnn-1.1.1-unix.patch
Patch13: FreeWnn-jlib-js-arraybounds-80669.patch
Patch14: FreeWnn-1.1.1-fix-x86-64-61907.patch
Patch15: FreeWnn-1.1.1-a017-jutils-shlib-89068.patch
Patch17: FreeWnn-pod-searchdesc-args-110750.patch
Patch18: FreeWnn-1.1.1-smpmake.patch
Patch19: FreeWnn-1.1.1-a017-jserver-64bit-128387.patch
Prereq: /sbin/chkconfig, grep, textutils, shadow-utils
Requires: chkconfig
Conflicts: wnn6
Obsoletes: FreeWnn-common
BuildRoot: %{_tmppath}/%{name}-%{upstreamversion}-root
BuildPrereq: ncurses-devel

%description
FreeWnn is a network-extensible system for converting Japanese Kana to
Kanji characters.

%package devel
Summary: Development library and header files for FreeWnn.
Group: Development/Libraries
Requires: FreeWnn-libs = %{version}-%{release}

%description devel
The FreeWnn-devel package contains files needed for building programs
which will use the FreeWnn Kana-to-Kanji conversion system.

%package libs
Summary: A runtime library for FreeWnn.
Group: System Environment/Libraries

%description libs
The FreeWnn-libs package contains the runtime library for running
programs with the FreeWnn Kana-to-Kanji conversion system.

%prep
%setup -q -n %{name}-%{upstreamversion}-a%{alpha}/Xsi
%patch0 -p2
%patch1 -p2
%patch2 -p2
%patch3 -p2
%patch4 -p2
%patch5 -p2 -b .ia64
%patch6 -p2 -b .shlib
%patch7 -p2 -b .reuid
%patch8 -p2 -b .fPIC
%patch9 -p2 -b .nosbit
%patch10 -p2 -b .dl
%patch11 -p2 -b .nonstrip
%patch12 -p2 -b .unix
%patch13 -p2 -b .bounds
%patch14 -p2 -b .x86_64
%patch15 -p2 -b .static
%patch17 -p1 -b .args
%patch18 -p2 -b .smpmake
%patch19 -p2 -b .64bit

# disable cWnn
sed '/^SUBDIRS=/s/ $(CWNNDIR)//' Makefile.in > Makefile.in.tmp
mv Makefile.in.tmp Makefile.in
# disable kWnn
sed '/^SUBDIRS=/s/ $(KWNNDIR)//' Makefile.in > Makefile.in.tmp
mv Makefile.in.tmp Makefile.in

%build
%configure

%{__make} %{?_smp_mflags} CDEBUGFLAGS="$RPM_OPT_FLAGS" ALLLANGDEF=-DJAPANESE

%install
%{__rm} -rf $RPM_BUILD_ROOT

make DESTDIR=$RPM_BUILD_ROOT install
make DESTDIR=$RPM_BUILD_ROOT install.man

%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/man/ja/man1
%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/man/ja/man3
%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/man/ja/man4
%{__mkdir_p} $RPM_BUILD_ROOT/%{_datadir}/man/ja/man5
cd $RPM_BUILD_ROOT/%{_datadir}/man/man1
for i in atod.1 atof.1 dtoa.1 jserver.1 oldatonewa.1 \
	uum.1 wddel.1 wdreg.1 \
	wnnkill.1 wnnstat.1 wnntouch.1
do
	mv $i $RPM_BUILD_ROOT/%{_datadir}/man/ja/man1/
done
cd $RPM_BUILD_ROOT/%{_datadir}/man/man3
for i in *.3
do
	mv $i $RPM_BUILD_ROOT/%{_datadir}/man/ja/man3/
done

cd $RPM_BUILD_ROOT/%{_datadir}/man/man4
for i in 2a_ctrl.4 2b_romkana.4 cvt_key_tbl.4 fzk.data.4 fzk.u.4 \
	hinsi_data.4 jserverrc.4 mode.4 serverdefs.4 ujis_dic.4 \
	uumkey.4 uumrc.4 wnnenvrc.4
do
	mv $i $RPM_BUILD_ROOT/%{_datadir}/man/ja/man4/
done

cd $RPM_BUILD_ROOT/%{_datadir}/man/man5
for i in pubdic.5 usr_dic.5
do
	mv $i $RPM_BUILD_ROOT/%{_datadir}/man/ja/man5/
done

%{__mkdir_p} ${RPM_BUILD_ROOT}/etc/rc.d/init.d
%{__install} -m755 %{SOURCE1} \
	$RPM_BUILD_ROOT/etc/rc.d/init.d/FreeWnn
ln -sf /var/lib/wnn/ja/dic ${RPM_BUILD_ROOT}/etc/FreeWnn/ja/dic

%clean
%{__rm} -rf $RPM_BUILD_ROOT

%pre
# add user 'wnn'
if  grep -q '^wnn:' /etc/passwd
then
    /usr/sbin/userdel wnn
fi
/usr/sbin/useradd -c "Wnn Input Server" -d %{_localstatedir}/lib/wnn -r  -s /sbin/nologin -u 49 wnn

%post
/sbin/chkconfig --add FreeWnn
#/sbin/chkconfig --level 0123456 FreeWnn off
/usr/bin/wnntouch  /var/lib/wnn/ja/dic/{gerodic/g-jinmei.dic,pubdic/*.*}

%preun
if [ "$1" = "0" ]; then
    /sbin/service FreeWnn stop > /dev/null 2>&1 || :
    /sbin/chkconfig --del FreeWnn
fi

%postun
if [ "$1" -ge "1" ]; then
    /sbin/service FreeWnn condrestart >/dev/null 2>&1 || :
fi

%post libs -p /sbin/ldconfig

%postun libs -p /sbin/ldconfig

%files
%defattr(-,root,root)
%dir /var/lib/wnn
%dir /var/lib/wnn/ja
%doc CONTRIBUTORS COPYRIGHT* ChangeLog Wnn/manual Wnn/manual.en
%config /etc/rc.d/init.d/FreeWnn
%attr(-,wnn,root) %{_bindir}/atod
%attr(-,wnn,root) %{_bindir}/dtoa
%attr(-,wnn,root) %{_bindir}/oldatonewa
%attr(-,wnn,root) %{_bindir}/wdreg
%attr(-,wnn,root) %{_bindir}/wnnstat
%attr(-,wnn,root) %{_bindir}/atof
%attr(711,wnn,root) %{_bindir}/jserver
%attr(-,wnn,root) %{_bindir}/wddel
%attr(-,wnn,root) %{_bindir}/wnnkill
%attr(-,wnn,root) %{_bindir}/wnntouch
%{_mandir}/ja/man1/*
%{_mandir}/ja/man4/*
%{_mandir}/ja/man5/*
%attr(-,wnn,root) /var/lib/wnn/ja/dic
%dir /etc/FreeWnn
%config /etc/FreeWnn/cvt_key_empty
%config /etc/FreeWnn/cvt_key_tbl
%config /etc/FreeWnn/cvt_key_tbl.ST
%config /etc/FreeWnn/cvt_key_tbl.gm
%config /etc/FreeWnn/cvt_key_tbl.kt
%config /etc/FreeWnn/cvt_key_tbl.mv
%config /etc/FreeWnn/cvt_key_tbl.vt
%dir /etc/FreeWnn/ja
/etc/FreeWnn/ja/dic
%config /etc/FreeWnn/ja/hinsi.data
%config /etc/FreeWnn/ja/jserverrc
%config /etc/FreeWnn/ja/libwnn.msg
%config /etc/FreeWnn/ja/rk
%config /etc/FreeWnn/ja/rk.vi
%config /etc/FreeWnn/ja/uum.msg
%config /etc/FreeWnn/ja/uumkey
%config /etc/FreeWnn/ja/uumkey.omr
%config /etc/FreeWnn/ja/uumkey_e
%config /etc/FreeWnn/ja/uumrc
%config /etc/FreeWnn/ja/uumrc.omr
%config /etc/FreeWnn/ja/uumrc.rev
%config /etc/FreeWnn/ja/uumrc_e
%config /etc/FreeWnn/ja/uumrc_vi
%config /etc/FreeWnn/ja/wnnenvrc
%config /etc/FreeWnn/ja/wnnenvrc.omr
%config /etc/FreeWnn/ja/wnnenvrc.rem
%config /etc/FreeWnn/ja/wnnenvrc.rev
%config /etc/FreeWnn/ja/wnnenvrc_R
%config /etc/FreeWnn/ja/wnnenvrc_R.omr
%config /etc/FreeWnn/ja/wnnenvrc_R.rem
%config /etc/FreeWnn/ja/wnnstat.msg
%dir /etc/FreeWnn/lt_LN
/etc/FreeWnn/lt_LN/rk
%config /etc/FreeWnn/lt_LN/uum.msg
%config /etc/FreeWnn/lt_LN/uumkey
%config /etc/FreeWnn/lt_LN/uumkey_e
%config /etc/FreeWnn/lt_LN/uumrc
%config /etc/FreeWnn/serverdefs

%files devel
%defattr(-,root,root)
%dir %{_includedir}/wnn
%{_includedir}/wnn/*
%{_libdir}/libjd.a
%{_libdir}/libwnn.a
%{_libdir}/libwnn.so
%{_mandir}/ja/man3/*

%files libs
%defattr(-,root,root)
%attr(755,root,root) %{_libdir}/libwnn.so.0.0.1
%{_libdir}/libwnn.so.0

%changelog
* Mon Aug  9 2004 Jens Petersen <petersen@redhat.com> - 1.11-36.2
- add FreeWnn-1.1.1-a017-64bit-128387.patch to fix problems
  with jserver on 64bit archs (128387)
- add some doc files
- Backport the following changes to 1.11-36:

* Tue Jun 15 2004 Elliot Lee <sopwith@redhat.com>
- add FreeWnn-1.1.1-smpmake.patch to enable smp build
- use $RPM_OPT_FLAGS

* Tue Mar 23 2004 Jens Petersen <petersen@redhat.com>
- add condrestart command to init script and use it in %%postun
- only chkconfig --del if erasing package
- merge FreeWnn-common into main FreeWnn package, make it obsoleted and update
  description
- remove the disabled cWnn, kWnn and tWnn subpackages from the spec file
- fix wnn's home dir and no need to add wnn4 to /etc/services (notting,#118651)
- add FreeWnn-pod-searchdesc-args-110750.patch to fix args of searchdesc in
  pod.c (d.binderman,#110750)

* Tue Dec 16 2003 Jens Petersen <petersen@redhat.com>
- add FreeWnn-1.1.1-a017-jutils-shlib-89068.patch to link utilities
  against libwnn.so (#89068) [reported by Jeremy Katz]

* Thu Dec  4 2003 Jens Petersen <petersen@redhat.com>
- apply FreeWnn-1.1.1-fix-x86-64-61907.patch (#61907) [Akira Tagoh]
- make shared library executable [Florian Laroche]

* Tue Oct 28 2003 Jens Petersen <petersen@redhat.com>
- exit init.d script with actual return value

* Thu May 15 2003 Elliot Lee - 1.11-36
- Rebuild

* Mon Apr 21 2003 Jens Petersen <petersen@redhat.com> - 1.11-35
- fix array bounds in jlib/js.c (#80669) [patch from d.binderman@virgin.net]
- make FreeWnn-devel require FreeWnn-libs (#52351)

* Wed Jan 22 2003 Tim Powers <timp@redhat.com>
- rebuilt

* Sat Dec 21 2002 Yukihiro Nakai <ynakai@redhat.com>
- Change login shell to /sbin/nologin (#80167)

* Mon Dec 16 2002 Yukihiro Nakai <ynakai@redhat.com>
- extract *bz2 patches
- Define AF_UNIX
- Remove PF_INET code from jserver
- Set FreeWnn on by default

* Thu Dec 12 2002 Yukihiro Nakai <ynakai@redhat.com>
- ctkWnn off

* Wed Nov 20 2002 Tim Powers <timp@redhat.com>
- rebuild for all arches

* Fri Aug 23 2002 Yukihiro Nakai <ynakai@redhat.com> 1.11-27
- Set FreeWnn server off by default. (#69119)
- Add cwnntouch to %%files

* Thu Jul 18 2002 Akira TAGOH <tagoh@redhat.com> 1.11-26
- add some owned directory.

* Fri Jun 21 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Wed Jun 19 2002 Akira TAGOH <tagoh@redhat.com> 1.11-24
- FreeWnn-nonstrip.patch: applied to fix the stripped binary.
- s/Copyright/License/

* Wed Jun 05 2002 Yukihiro Nakai <ynakai@redhat.com>
- Remove warning message. (#65781)

* Thu May 23 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Sat Jan 26 2002 Florian La Roche <Florian.LaRoche@redhat.de>
- add further Prereq: /sbin/chkconfig to subpackages

* Wed Jan 09 2002 Tim Powers <timp@redhat.com>
- automated rebuild

* Mon Aug 27 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add patch to set limit the wnn user directory.

* Tue Aug 14 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add nosbit patch
- Change *server mode 4711 -> 711

* Mon Jul 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add ncurses-devel to BuildPrereq. (#44720)
- Add chkconfig to reduce build errors.

* Mon Jul  9 2001 Matt Wilson <msw@redhat.com>
- disable cWnn, tWnn, kWnn and their subpackages
- re-enable [ctk]Wnn

* Tue Feb  6 2001 Matt Wilson <msw@redhat.com>
- added Prereq: /sbin/chkconfig to main package
- added Prereqs for common subpackage

* Mon Jan 29 2001 Trond Eivind Glomsrd <teg@redhat.com>
- new init style (no gprintf)

* Wed Jan 24 2001 Adrian Havill <havill@redhat.com>
- fixed useradd to be consistent with other useradd pkg behavior
- changed default uid/gid to match internal RH allocation

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- Add post and postun for -devel, -libs
- More fix about grep command.
- defattr added.
- Add -fPIC patch for IA64
- Update FreeWnn.init, cWnn.init, kWnn.init, tWnn.init
  to suppport RH color'ed

* Tue Jan 23 2001 Yukihiro Nakai <ynakai@redhat.com>
- secured so both EUID and RUID are set (havill@redhat.com)

* Mon Jan 22 2001 Yukihiro Nakai <ynakai@redhat.com>
- Split the runtime libraries.
- Build libwnn.so
- bzip2

* Sat Dec 19 2000 Satoru Sato <ssato@redhat.com>
- fix SPEC

* Sat Dec 09 2000 Yukihiro Nakai <ynakai@redhat.com>
- Add ia64 patch.

* Thu Sep 13 2000 Satoru Sato <ssato@redhat.com>
- (c|k|t)Wnn daemon are not started by default.

* Thu Sep  7 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- initfile move back /etc/init.d -> /etc/rc.d/init.d

* Fri Aug  4 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- move /etc/rc.d/init.d -> /etc/init.d

* Fri Aug  4 2000 ISHIKAWA Mutsumi <ishikawa@redhat.com>
- ported from Vine Linux
- Built for RedHat 7.0

* Tue Jul 25 2000 Lisa Sagami <czs14350@mb.infoweb.ne.jp>
- changed: each package (except devel) owns /etc/FreeWnn/* by adding %dir
- modified again *.init to do with socket left in /tmp 

* Fri Jul 14 2000 Lisa Sagami <czs14350@nifty.ne.jp>
- add %pre to addusr 127/wnn to avoid non-root build failure
- modified *.init to do with socket left in /tmp 
- correct %doc

* Tue Jul 11 2000 Masato Bito <masato@nets.ce.hiroshima-cu.ac.jp>
- 1.1.1-1vl3
- modified %patch0 -p3 -> %patch0 -p2
- modified BuildRoot:

* Thu Jul  6 2000 Jun Nishii <jun@vinelinux.org>
- 1.1.1-1vl2
- fix bug in FreeWnn-ja-a017.patch

* Wed Jul  5 2000 Jun Nishii <jun@vinelinux.org>
- 1.1.1-1vl1
- handle man page compress
- update to FreeWnn-1.1.1-a017

* Mon Jan 31 2000 Norihito Ohmori <nono@kondara.org>
- ja_JP -> ja
- configuration file move to /etc
- change group.
- add cWnn and kWnn.
- add FreeWnn-common Package.
- remove sample.eggrc

* Tue Jan 25 2000 Norihito Ohmori <nono@vinelinux.org>
- add defattr and attr for %files section

* Tue Nov 23 1999 Norihito Ohmori <ohmori@flatout.org>
- add Requires: chkconfig
- Conflicts change from Wnn6 to wnn6

* Fri Nov 12 1999 MATSUBAYASHI 'Shaolin' Kohji <shaolin@rins.st.ryukoku.ac.jp>
- FreeWnn-1.1.1-0.a013.4
- added Prereq: grep,textutils

* Wed Nov 10 1999 Jun Nishii <jun@flatout.org>
- remove cWnn and kWnn

* Sun Nov  7 1999 Yasuhide OOMORI <dasen@typhoon.co.jp>
- [FreeWnn-1.1.1-0.a013.2]
- Added a sample file of .eggrc to utilize gerodic.
- Now do not ldconfig after installation of FreeWnn-devel.
- Enabled you to compile with multi processors.
- Added 'Prereq: shadow-utils' for installation.
- Modified FreeWnn-jserver.script against error at boot time.

* Wed Oct 20 1999 Yasuhide OOMORI <dasen@typhoon.co.jp>
- [FreeWnn-1.1.1-0.a013.1]
- Updated to FreeWnn-1.1.1-a013.
- Separated cWnn,kWnn packages again.
- Make this package relocatable.
- Keep jserverrc and wnnenvrc when upgrading.

* Fri Sep 24 1999 Masaru Yokoi <yokoi @yk.fks.ryukoku.ac.jp>
- [FreeWnn-1.10-3]
- Added /var/lib/wnn/*/dic/usr .
- Moved libwnn.a from FreeWnn package to FreeWnn-devel package.
- Moved Japanese manuals from /usr/X11R6/man/man*
- to /usr/X11R6/man/ja_JP.ujis/man* .

* Wed Aug 11 1999 Masaru Yokoi <yokoi@yk.fks.ryukoku.ac.jp>
- First release.  Original idea is Sat Jul 12 1999 Norihito Ohmori
- <ohmori@flatout.org>

